Index: /branches/tracy3-3.10.1b/tracy/tracy/src/t2elem.cc
===================================================================
--- /branches/tracy3-3.10.1b/tracy/tracy/src/t2elem.cc	(revision 22)
+++ /branches/tracy3-3.10.1b/tracy/tracy/src/t2elem.cc	(revision 23)
@@ -1,3 +1,3 @@
-/*Tracy-3
+/* Tracy-3
 
  J. Bengtsson, CBP, LBL      1990 - 1994   Pascal version
@@ -9,5 +9,4 @@
  Element propagators.                                                      */
 
-
 double c_1, d_1, c_2, d_2, cl_rad, q_fluct;
 double I2, I4, I5, dcurly_H, dI4;
@@ -20,6 +19,4 @@
 
 // Dynamic model
-
-
 
 /****************************************************************************/
@@ -84,15 +81,12 @@
 
  Purpose:
- Get the longitudinal momentum ps; for the exact/approximation Hamiltonian
+ Get the longitudinal momentum ps
  
     for approximation Hamitonian:
     ps = 1+delta   
     
-    
     For exact hamitonian:
     
-    (1) ps = sqrt((1+delta)^2 - px_^2 - py_^2)
-    
-    (2) using the check of TEAPOT to check ps < 0 
+    ps 
  **********************************************************/
 template<typename T>
@@ -101,5 +95,5 @@
     T p_s, p_s2;
 
-   if (!globval.H_exact)
+    if (!globval.H_exact)
     p_s = 1.0+x[delta_];
     else {
@@ -109,10 +103,7 @@
         else {
             // avoid compile warning
-            //p_s = 0.0;
-	     p_s = 1.0e-20;
-	    cout << "        " << 1+x[delta_] << "   " << x[px_] << "   " << x[py_] << endl;
+            p_s = 0.0;
             printf("get_p_s: *** Speed of light exceeded!\n");
-           // exit_(1);
-	    
+            exit_(1);
         }
     }
@@ -124,9 +115,15 @@
 
  Purpose:
- Exact Drift pass in the curvilinear coordinate for the dipole
-
- See Eqn. (10.26) on page 307 in E. Forest's beam dynamics, a new attitude
- 
- H(x,y,cT,px,py,delta) =(1 + h_ref*x) * sqrt((1+delta)^ - px^2 - py^2) + delta                                  
+ Drift pass
+
+ If H_exact = false, using approximation Hamiltonian:
+
+                                   px^2+py^2
+	      H(x,y,l,px,py,delta) = -------------
+	                               2(1+delta)     
+       
+
+ Otherwise, using exact Hamiltonian
+
 
  Input:
@@ -144,67 +141,4 @@
 
  Specific functions:
- 
- 
- 
- Comments:
- 
- Test version....rewritten by Jianfeng zhang @ LAL, 31/07/2013
-
- ****************************************************************************/
-
-
-template<typename T>
-void Drift(double L,double h_bend, ss_vect<T> &x) {
-    T u;
-    ss_vect<T> x0;
-
-    x0=x;
-    
-    if (globval.H_exact) {
-      if(get_p_s(x) == 0)
-	return;
-
-      x[x_] = x0[x_]/cos(L*h_bend)/(1-x0[px_]/get_p_s(x)*tan(L*h_bend));
-      x[px_]= x0[px_]*cos(L*h_bend) + get_p_s(x)*sin(L*h_bend);
-      x[y_] = x0[y_]+x0[px_]*x0[x_]*tan(L*h_bend)/get_p_s(x)/(1-x0[px_]/get_p_s(x)*tan(L*h_bend));
-      x[py_]= x0[py_];
-      x[ct_]= x0[ct_]+((1+x0[delta_])*x0[x_]*tan(L*h_bend))/get_p_s(x)/(1-x0[px_]/get_p_s(x)*tan(L*h_bend));
- 
-    
-    }
-}
-
-/****************************************************************************/
-/* Drift(double L, ss_vect<T> &x)
-
- Purpose:
- Drift pass in the Cartesian coordinate
-
- If H_exact = false, using approximation Hamiltonian (only valid for big ring):
-
-                                       px^2+py^2
-	      H(x,y,cT,px,py,delta) = -------------
-	                               2(1+delta)     
-       
-
- Otherwise, using the exact Hamiltonian (valid for small ring) 
- (J. Bengtsson: Tracy-2 user's mannual):
- 
- H(x,y,cT,px,py,delta) =(1 + h_ref*x) * sqrt((1+delta)^ - px^2 - py^2) + delta                                  
-
- Input:
- L:  drift length
- &x:  pointer to initial vector: x
-
- Output:
- none
-
- Return:
- none
-
- Global variables:
-
-
- Specific functions:
 
  ****************************************************************************/
@@ -215,15 +149,11 @@
     T u;
 
-    if (globval.H_exact) {
-      if(get_p_s(x) == 0)
-	return;
-      
-   u = L/get_p_s(x);
+    if (!globval.H_exact) {
+    u = L/(1.0+x[delta_]);
+    x[ct_] += u*(sqr(x[px_])+sqr(x[py_]))/(2.0*(1.0+x[delta_]));
+    } else {
+    u = L/get_p_s(x);
     x[ct_] += u*(1.0+x[delta_]) - L;
-    } else {
-     u = L/(1.0+x[delta_]);
-    x[ct_] += u*(sqr(x[px_])+sqr(x[py_]))/(2.0*(1.0+x[delta_]));
-    }
-    
+    }
     x[x_] += x[px_] * u;
     x[y_] += x[py_] * u;
@@ -671,8 +601,7 @@
     Correction for magnet gap (longitudinal fringe field)
 
-    Input: 
-     irho:         h = 1/rho [1/m]
-     phi:         dipole edge (entrance or exit) angle
-     gap:        full gap between poles
+     irho h = 1/rho [1/m]
+     phi  dipole edge angle
+     gap  full gap between poles
 
                              2
@@ -683,10 +612,6 @@
      K1 is usually 1/2
      K2 is zero here                                                  
-     For the type of Tanh-like fringe field
-     
-
-     18/06/2012  Jianfeng Zhang@LAL
-     
-     Fix the bug to calculate psi for the sector magnets which has phi=0
+
+
 
 *********************************************************************/
@@ -697,86 +622,11 @@
     const double k1 = 0.5, k2 = 0.0;
 
-//     if (phi == 0.0)  //NOT hard edge, but sector magnets!!!
-//         psi = 0.0;  
-//     else
+    if (phi == 0.0)  //hard edge
+        psi = 0.0;  
+    else
         psi = k1 * gap * irho * (1.0 + sqr(sin(dtor(phi)))) / cos(dtor(phi))
                 * (1.0 - k2 * gap * irho * tan(dtor(phi)));
 
     return psi;
-}
-
-/*****************************************************************
- * Exact map of the sector dipole
- * 
- * Forest's beam dynamics P.360 Eqn. (12.18)
- * Also see Laurent's thesis: P219-220.
- * 
- * Written by Jianfeng Zhang @ LAL, 01/08/2013
- * 
- * Test version........................................
- * 
- * ****************************************************************/
-template<typename T>
-void dipole_kick(double L, double h_ref, double h_bend, ss_vect<T> &x){
-
-  ss_vect<T> x0;
-  T ps, u, dpxf;
-    
-  x0 = x;
-  ps = get_p_s(x0);
-  
-  u = sqrt(sqr(1+x0[delta_])-sqr(x0[py_]));
-  
-  x[py_] = x0[py_];
-  
-  x[delta_] =x0[delta_];
-  
-  x[px_]= x0[px_]*cos(L*h_ref) + (ps -h_bend*(1/h_ref+x0[x_]))*sin(L*h_ref);
-  
-  dpxf = h_ref*sqrt((1+x[delta_])*(1+x[delta_]) - x[px_]*x[px_] - x[py_]*x[py_])-h_bend*(1+h_ref*x[x_]);
-  
-  
-  x[y_] += h_ref/h_bend*x0[py_]*L + x0[py_]/h_bend*(asin(x0[px_]/u)-asin(x[px_]/u));
-  
-  x[x_] = 1/(h_bend*h_ref)*(h_ref*sqrt(sqr(1+x[delta_])-sqr(x[px_])-sqr(x[py_]))-dpxf - h_bend);
-  
-  x[ct_] += (1+x0[delta_])*h_ref/h_bend*L + (1+x0[delta_])/h_bend*(asin(x0[px_]/u)-asin(x[px_]/u));
- 
-}
-
-/*****************************************************************
- * pure multipole kick
- * 
- * Forest's beam dynamics P.360 Eqn. (12.18)
- * Also see Laurent's thesis: P219-220.
- * 
- * Written by Jianfeng Zhang @ LAL, 01/08/2013
- * 
- * Test version........................................
- * 
- * ****************************************************************/
-template<typename T>
-void multipole_kick(int Order, double MB[], double L, double h_bend, ss_vect<T> &x){
-
-  int j=0;
-  ss_vect<T> x0;
-  
-  T ByoBrho = 0, BxoBrho = 0, ByoBrho1=0 ;
-  
-  if ((h_bend != 0.0) || ((1 <= Order) && (Order <= HOMmax))) {
-        x0 = x;
-        /* compute the total magnetic field Bx and By with Horner's rule */
-        ByoBrho = MB[HOMmax + Order]; // normalized By, By/(p0/e)
-        BxoBrho = MB[HOMmax - Order]; // normalized Bx, Bx/(p0/e)
-        for (j = Order - 1; j >= 1; j--) {
-            ByoBrho1 = x0[x_] * ByoBrho - x0[y_] * BxoBrho + MB[j + HOMmax];
-            BxoBrho = x0[y_] * ByoBrho + x0[x_] * BxoBrho + MB[HOMmax - j];
-            ByoBrho = ByoBrho1; 
-	}
-  }
-  
-  x[px_] -= L * (ByoBrho + h_bend*1); 
-	//vertical kick due to the magnets
-        x[py_] += L * BxoBrho;
 }
 
@@ -786,32 +636,24 @@
 
   Purpose:
-        Refer to Tracy 2 manual.
-        Calculate multipole kick. 
-  , 
-  (1)     The exact Hamiltonian is
+        Calculate multipole kick. The Hamiltonian is
 
             H = A + B where A and B are the kick part defined by
-                 
-                 (exact form of the H of the drift)
-                 A(x,y,-l,px,py,dP) = -sqrt( (1 + delta)^2 - px^2 - py^2 )  + delta 
-                                      
-                 (exact form of the H of the kick from the magnet)                                       
-                 B(x,y,-l,px,py,dP) = -h*x*sqrt( (1 + delta)^2 - px^2 - py^2 ) + h x + h^2*x^2/2 + int(Re(By+iBx)/Brho)   
-                 
-                 so this is the exact Hamitonian for small ring.
-                 
-
-	The kick is given by
-                                                                                                e                     
-         Dp_x = L* (h_ref*sqrt( (1 + delta)^2 - (px^2 + py^2) ) - h_bend - x*h_bend*h_ref -   ---- B_y ) 
-                                                                                               p_0                 
-         Dp_y = L* e/p_0 * B_x
-         
-         x    = L* h*x_ref / sqrt( (1 + delta)^2 - px^2 - py^2) * p_x
-         
-         y    = L* h*x_ref / sqrt( (1 + delta)^2 - px^2 - py^2) * p_y
-         
-         CT   = L* h*x_ref / sqrt( (1 + delta)^2 - px^2 - py^2) * (1+delta)
-                                                                                           
+                                         2    2
+                                       px + py
+                 A(x,y,-l,px,py,dP) = ---------
+                                       2(1+dP)
+                                                   2 2
+                 B(x,y,-l,px,py,dP) = -h*x*dP + 0.5 h x + int(Re(By+iBx)/Brho)
+
+                 so this is the appproximation for large ring
+                 the chromatic term is missing hx*A
+
+
+		The kick is given by
+
+              e L       L delta    L x              e L
+     Dp_x = - --- B_y + ------- - ----- ,    Dp_y = --- B_x
+              p_0         rho     rho^2             p_0
+
     where
         e      1
@@ -823,51 +665,12 @@
                            /
                            ====
-  
-  (2)     The approximate Hamiltonian is
-
-            H = A + B where A and B are defined by
-                                         2    2
-                                       px + py
-                 A(x,y,-l,px,py,dP) = ---------                   (approximate form of the H of the drift)
-                                      2(1+delta)
-                                                        2 2
-                 B(x,y,-l,px,py,dP) = -h*x*delta + 0.5 h x + int(Re(By+iBx)/Brho)   (approximate form of the H of the kick from the magnet)
-
-                 so this is the appproximation for large ring
-                 the chromatic term is missing hx*A
-
-
-		The kick is given by
-
-              e L       L delta    L x              e L
-     Dp_x =  --- B_y + ------- - ----- ,    Dp_y = --- B_x
-              p_0         rho     rho^2             p_0
-
-     //second order of the Hamiltonian motion
-     x    =  h_ref * x_0 / (1+delta) * p_x
-     
-     y    =  h_ref * x_0 / (1+delta) * p_y
-     
-    CT    =  h_ref * x_0 / (1+delta) * (p_x^2 + p_y^2)/2/(1+delta)
-     
-    where
-        e      1
-      --- = -----
-      p_0   B rho   
-                           ====
-                           \ 
-      (B_y + iB_x) = B rho  >   (ia_n  + b_n ) (x + iy)^n-1
-                           /
-                           ====
-
-                    = B rho [(b_n*x - a_n*y) + i*(bn*y + an*x) + b_(n-1) + i*a_(n-1)] * (x+iy)^n-2
-                    =......
- 
+
  Input:
  Order  maximum non zero multipole component
  MB     array of an and bn, magnetic field components
  L      multipole length
- h_bend   B_dipole/Brho is the dipole field normalized by the reference momentum; one of the example is the combined dipole
- h_ref   1/rho [m^-1] is the curvature of the reference orbit in the dipoles which is used in curvilinear coordinate,
+ h_bend   1/rho in curvilinear coordinate,
+ 0    in cartisian cooridinate.
+ h_ref   1/rho [m^-1]
  x      initial coordinates vector
 
@@ -885,7 +688,5 @@
 
  Comments:
- 06/11/2012     Jianfeng Nadolski @ LAL
-                Fix the bug in the kick map of the exact Hamiltonian. 
-                Add the second order of the approximate Hamiltonian.
+ none
 
  **************************************************************************/
@@ -895,14 +696,12 @@
     int j;
     T BxoBrho, ByoBrho, ByoBrho1, B[3];
-    T sqrtpx, dpx, ps2new, psnew;
-    T n1, n2;
     ss_vect<T> x0, cod;
-    T u=0.0;
-    
+
     if ((h_bend != 0.0) || ((1 <= Order) && (Order <= HOMmax))) {
         x0 = x;
-        /* compute the total magnetic field Bx and By with Horner's rule */
+        /* compute field with Horner's rule */
         ByoBrho = MB[HOMmax + Order]; // normalized By, By/(p0/e)
         BxoBrho = MB[HOMmax - Order]; // normalized Bx, Bx/(p0/e)
+
         for (j = Order - 1; j >= 1; j--) {
             ByoBrho1 = x0[x_] * ByoBrho - x0[y_] * BxoBrho + MB[j + HOMmax];
@@ -911,5 +710,4 @@
         }
 
-        
         if (globval.radiation || globval.emittance) {
             B[X_] = BxoBrho;
@@ -919,87 +717,12 @@
         }
 
-        //curvilinear cocodinates, from the dipole components
         if (h_ref != 0.0) {
-	  
-	  //exact Hamiltonian
-	  if (globval.H_exact) {
-	    
-	    if(get_p_s(x0)==0)
-	      return;
-	    
-	    //dipole kick map from the exact Hamiltonian; not symplectic
-// 	    u = L * h_ref * x0[x_] /get_p_s(x0);
-//             x[x_] += u * x0[px_];
-//             x[y_] += u * x0[py_];
-// 	    x[px_]-= L * (-h_ref * get_p_s(x0) + h_bend + h_ref * h_bend
-// 	             * x0[x_] + ByoBrho);
-//             x[ct_] += u * (1.0+x0[delta_]);
-	     
-	      //kick map due to the dipole vector potential
-	     // x[px_] -= L*(h_bend + h_ref*h_bend*x0[x_]+ByoBrho);
- 
-//          sqrtpx = sqrt(sqr(1+x0[delta_])-sqr(x0[py_]));
-// // 	
-// 	x[px_] = x0[px_]*cos(L*h_ref) + (get_p_s(x0)-h_bend*(h_ref+x0[x_]))*sin(L*h_ref)-L*ByoBrho;
-// 	
-// 	dpx = -x0[px_]*h_ref*sin(L*h_ref)+(get_p_s(x0)-h_bend*(h_ref+x0[x_]))*h_ref*cos(L*h_ref);
-// 	
-// 	x[x_] = 1/(h_bend*h_ref)*(h_ref*sqrt(sqr(1+x0[delta_])-sqr(x[px_])-sqr(x0[py_]))-dpx - h_bend);
-// 	
-// 	x[y_] += h_ref/h_bend*x0[py_]*L + x0[py_]/h_bend*(asin(sqrtpx*x0[px_])-asin(sqrtpx*x[px_]));
-// 	
-// 	x[ct_]+= (1+x0[delta_])*h_ref/h_bend*L + (1+x0[delta_])/h_bend*(asin(sqrtpx*x0[px_])-asin(sqrtpx*x[px_]));
-	
-        //map of a wedge 
-//          x[px_] = x0[px_]*cos(L*h_bend) + (get_p_s(x0) - h_ref*x0[x_])*sin(L*h_bend) -L*ByoBrho;
-// 	 
-// 	 sqrtpx = sqrt(sqr(1+x0[delta_])-sqr(x0[py_]));
-// 	 n1 = x0[px_]*sqrtpx;
-// 	 n2 = x[px_]*sqrtpx;
-// 	 
-//          x[x_] = x0[x_]*cos(L*h_bend) + (x0[x_]*x0[px_]*sin(2*L*h_bend)+sqr(sin(L*h_bend))*(2*x0[x_]*get_p_s(x0)-h_ref*sqr(x0[x_])))
-//                  /(sqrt(sqr(1+x0[delta_])-sqr(x[px_])-sqr(x0[y_]))+get_p_s(x0)*cos(L*h_bend)-x0[px_]*sin(L*h_bend));
-// 
-//          x[y_] += x0[py_]*L*h_bend*h_ref + x0[py_]*h_ref*(asin(n1) - asin(n2));
-//          x[ct_]+= (1+x0[delta_])*L*h_bend*h_ref + (1+x0[delta_])*h_ref*(asin(n1) - asin(n2));
-//  
-          }//approximate Hamiltonian 
-          else {//first order map
             x[px_] -= L * (ByoBrho + (h_bend - h_ref) / 2.0 + h_ref * h_bend
                     * x0[x_] - h_ref * x0[delta_]);
             x[ct_] += L * h_ref * x0[x_];
-  
-	    //  second order, cubic term of H, H3; has problem when do tracking...works for THOMX!!!!!
-	    // not symplectic????
-         if(0){	
-	    u = L * h_ref * x0[x_] /(1.0+x0[delta_]);
-            x[x_] += u * x0[px_];
-            x[y_] += u * x0[py_];
-	 //   x[px_]+= 0.5*u/x0[x_]*(x0[px_]*x0[px_]+x0[py_]*x0[py_]);
-            x[ct_] += u*(sqr(x0[px_])+sqr(x0[py_]))/(2.0*(1.0+x0[delta_]));
-            
-	   // cout << "test......2.....  u = " << u<< endl;
-	  }	
-      }
-	  
-	}//from other straight magnets 
-	else 
-            x[px_] -= L * (ByoBrho + h_bend*1); //h_bend should be trigger on for combined dipoles
-
-	//vertical kick due to the magnets
+        } else
+            x[px_] -= L * (ByoBrho + h_bend);
+
         x[py_] += L * BxoBrho;
-      
-	/*
-	if(h_ref == 0 && h_bend !=0){
-	sqrtpx = sqrt(sqr(1+x0[delta_])-sqr(x0[py_]));
-	ps2new = sqr(1+x0[delta_]) - sqr(x[px_]) -sqr(x0[py_]);
-	psnew = sqrt(ps2new);
-	
-	x[x_] += 1/h_bend*(psnew - get_p_s(x0));
-	x[y_] += x0[py_]/h_bend*(asin(x0[px_]*sqrtpx)-asin(x[px_]*sqrtpx));
-	x[ct_]+= (1+x0[delta_])/h_bend*(asin(x0[px_]*sqrtpx)-asin(x[px_]*sqrtpx));
-	}*/
-	
-	
     }
 }
@@ -1012,5 +735,5 @@
  Compute edge focusing for a dipole
  There is no radiation coming from the edge
- The standard formula used is : (SLAC-75, K. Brown's first order of fringe field but with the correction of 1/(1+delta) in R43)
+ The standard formula used is :
 
        px = px0 +  irho tan(phi) *x0
@@ -1029,7 +752,5 @@
  gap  = gap of the dipole for longitudinal fringing field (see psi)
  x    = input particle coordinates
-Entrance:   bool flag, true, then calculate edge focus and fringe field at the entrance of the dipole
-                       false,...........................................at the exit fo the dipole
- 
+
  Output:
  x    output particle coordinates
@@ -1053,121 +774,18 @@
 
  April 2011, No energy dependence for H-plane according to SSC-141 note (E. Forest)
- Agreement better with MAD8 (LNLS), SOLEIL small effect (.1). Modified by Laurent Nadolski @ soleil
- Comments: Jianfeng Zhang @ LAL, 05/06/2013
- This model only works for Soleil lattice, but not works for ThomX and SuperB DR lattice.
- 
- 18/06/2012  Jianfeng Zhang @ LAL
- Add the contribution of x' to the x[py_] for small ring like Thom-X, using Alexandre Loulergue's correction.
- This models works for ThomX, Soleil, and SuperB DR lattices; and 
- close to the Forest's model and K. Brown's models.
- 
+ Agreement better with MAD8 (LNLS), SOLEIL small effect (.1)
  ****************************************************************************/
 template<typename T>
-static void EdgeFocus(double irho, double phi, double gap, ss_vect<T> &x, bool Entrance) {
-  
-
+static void EdgeFocus(double irho, double phi, double gap, ss_vect<T> &x) {
     if (true) {
-      
-       // cout << "Dipole edge effect WITH Alex's  correction: " << endl;
-      
-      //with the contribution from the entrance angle of the particle at the edge
-// Original model, written by L. Nadolski, this is a reasonal model!!!! 
-//    warning: => diverging Taylor map (see SSC-141)
-//         x[px_] += irho * tan(dtor(phi)) * x[x_];
-//         x[py_] -= irho * tan(dtor(phi) - get_psi(irho, phi, gap)) * x[y_]
-//                 / (1.0 + x[delta_]);
-
-
-// K.Brown 2rd order transfer matrix of the dipole fringe field for sector dipoles (phi=0)
-// compared the fringe field model used in Tracy
-// results:  K. Brown's model is wrong for small ring like Thom-X!!!!
-// The original model of tracy is correct for tracking!!!!!!!!!!
-  /*
-  double psi;
-    psi=gap*0.5*irho*(1+sin(dtor(phi))*sin(dtor(phi)))/cos(dtor(phi));
- 
-    if(Entrance){
-   x[x_] += irho/2*x[y_]*x[y_];
-   x[px_] += 0.5*x[x_]*x[x_] + irho * tan(dtor(phi)) * x[x_]-0.5*x[y_]*x[y_];
-   x[py_] -= -irho*tan(-dtor(psi))*x[y_]+1*x[x_]*x[y_]+irho*x[px_]*x[y_]+ (irho*psi/cos(-dtor(psi))/cos(-dtor(psi))) * x[y_]
-                 / (1.0 + x[delta_]);
-    }
-    else
-    {
-       x[x_] -= irho/2*x[y_]*x[y_];
-   x[px_] += 0.5*x[x_]*x[x_] + irho * tan(dtor(phi)) * x[x_]-0.5*x[y_]*x[y_];
-   x[py_] -= -irho*tan(-dtor(psi))*x[y_]+1*x[x_]*x[y_]-irho*x[px_]*x[y_]+ (irho*psi/cos(-dtor(psi))/cos(-dtor(psi))) * x[y_]
-                 / (1.0 + x[delta_]);
-    }
-    */
-
-    //add the contribution of the entrance momentum of the particle, from Alex Loulergue. 
-    if(Entrance){
-       x[px_] += irho * tan(dtor(phi) +x[py_]/(1+x[delta_]*1)) * x[x_]/ (1.0 + x[delta_]*0);
-       x[py_] -= irho * tan(dtor(phi) + x[px_]/(1+x[delta_]*1) - get_psi(irho, phi, gap)/(1+x[delta_]*0)) * x[y_]
-                / (1.0 + x[delta_]*0);
-    }else{
-       x[px_] += irho * tan(dtor(phi) - x[py_]/(1+x[delta_]*1)) * x[x_]/ (1.0 + x[delta_]*0);
-       x[py_] -= irho * tan(dtor(phi) - x[px_]/(1+x[delta_]*1) - get_psi(irho, phi, gap)/(1+x[delta_]*0)) * x[y_]
-                / (1.0 + x[delta_]*0);
-    }
-      
-    } else {//original one
-
-   //cout << "Dipole edge effect WITHOUT Alex's  correction: " << endl;
+        // warning: => diverging Taylor map (see SSC-141)
         x[px_] += irho * tan(dtor(phi)) * x[x_];
-        x[py_] -= irho * tan(dtor(phi) - get_psi(irho, phi, gap)) * x[y_]/ (1.0 + x[delta_]*1);
-    }
-}
-
-
-/******************************************************************
- template<typename T>
-static void BendCurvature(double irho, double H, ss_vect<T> &x)
-
-The leanding order term T211, T233, and T413 on page 117 & page 118
-of the dipole edge effect in SLAC-75, using the symplectic
-form in 
- E. Forest: "Fringe field in MAD, Part II: Bend curvature in MAD-X for the 
-             mudule PTC". 
-             P.10 Eq. (5) and (42).
- 
- For an rectangular dipole, the bending curvature term is zero, since 1/R = 0.
- 
- irho:   curvature of the central orbit inside the dipole
- H:      curvature of the entrance/exit pole face of the dipole
- 
- Comments:
- Written by Jianfeng Zhang @ LAL, 01/10/2012.
-******************************************************************/
-template<typename T>
-static void BendCurvature(double irho,  double H, ss_vect<T> &x) {
-  
-  if(trace)
-  cout << "Forest's bend curvature...."<<endl;
-  
-  T pm2,u, coeff1, coeff2,coeff3;
-  
-   ss_vect<T> x0;
-   
-   x0 = x;
-  
-   pm2 = sqr(1+x0[delta_]) - sqr(x0[px_]); 
-   u = irho*H/2/pm2;
-   
-   coeff1 = u * 2*x0[px_]*(1+x0[delta_])/pm2; //
-   coeff2 = u * (1+x0[delta_]); //
-   coeff3 = u * (pm2 - 2*(1+x0[delta_]))/pm2; 
-   
- 
-   x[x_]  += x0[x_]/(1-coeff1*x0[y_]*x0[y_]);
-   x[px_] -= coeff2*x0[y_]*x0[y_] - irho*H/2*sqr(x0[x_]);
-   x[py_] -= 2*coeff2*x[x_]*x0[y_];
-   x[ct_] -= coeff3*x[x_]*x0[y_]*x0[y_];
-}   
-   
-   
-      
- 
+        x[py_] -= irho * tan(dtor(phi) - get_psi(irho, phi, gap)) * x[y_]
+                / (1.0 + x[delta_]);
+    } else {
+        x[px_] += irho * tan(dtor(phi)) * x[x_];
+        x[py_] -= irho * tan(dtor(phi) - get_psi(irho, phi, gap)) * x[y_];
+    }
+}
 
 /****************************************************************
@@ -1176,14 +794,8 @@
 
   Purpose:
-     Rotate from the beam coorinate to the dipole face.
-     This is a pure geometric operation, no physical meaning.
-     
-     See P.307 Eq. (10.26) in 
-     E. Forest "Beam dynamics: A new attitude and framework".
-     
+     the effect of edge focusing of the dipole
   Input:
      phi:  entrance or exit angle of the dipole edge
      x:    initial cooridinate of the particle
-     
   Output:
   
@@ -1207,5 +819,4 @@
 }
 
-
 /***************************************************************
 template<typename T>
@@ -1213,10 +824,6 @@
 
   Purpose:
-     the effect of longitudinal fringe field using exact Hamitonian.
-     This is a hard effect model, the fringe field and edge focus
-     happens at the entrance/exit point of the dipole pole face.
-
-      include only the first order of irho.
-     Input:
+     the effect of longitudinal fringe field using exact Hamitonian 
+  Input:
   
   Output:
@@ -1242,84 +849,8 @@
         x[ct_] = x1[ct_] - coeff * x1[px_] * sqr(x[y_]) * (1.0 + x1[delta_])
                 / ps3;
-    } else {//give the error message and set the unstable x value during the tracking
-             //this x value will be discard as an unstable value during the tracking
+    } else {
         printf("bend_fringe: *** Speed of light exceeded!\n");
-        x[y_] = 10;
-	x[x_] = 10;
-	x[py_] =10;
-	x[ct_] = 10;
-	//exit_(1);
-    }
-}
-
-/***************************************************************
-template<typename T>
-void bend_fringe(double hb, double gap, ss_vect<T> &x)
-
-  Purpose:
-     the effect of longitudinal fringe field using exact Hamitonian.
-     This is a hard effect model, the fringe field and edge focus
-     happens at the entrance/exit point of the dipole pole face.
-
-      include the second order of irho.
-      
-      See E. Forest and et al. 
-      "Fringe field in MAD Part I: Second order Fringe in MAD-X for the module PTC",
-      P. 8-9, Eq. (35) and (34).
- 
-   Input:
-  
-  Output:
-  
-  Return:
-  
-****************************************************************/
-template<typename T>
-void bend_fringe(double hb, double gap, ss_vect<T> &x) {
-  
-  bool track=false;
-  
-  if(track) cout << "bend_fringe(): Forest's model"<<endl;
-  
-    T coeff1,coeff2,coeff3,coeff4;
-    T ps, ps2, ps3, ps5;
-    
-    ss_vect<T> x1;
- 
-    gap = gap*0.5;
-    
-    x1 = x;
-    ps = get_p_s(x);
-    
-    if(ps==0)
-      return;
-    
-    ps2 = sqr(ps);
-    ps3 = ps * ps2;
-    ps5 = ps2*ps3; 
-    
-    coeff1 = 1.0 - 4.0*sqr(hb)*gap*x1[py_]*x1[y_]/ps3;
-    coeff2 = sqr(hb)*gap*2*x1[px_]*(2*sqr(x1[px_])-sqr(1.0+x1[delta_]))/ps5 +  
-            hb*(ps/(sqr(1+x1[delta_])-sqr(x1[px_])) + 2*sqr(x1[px_])*ps/sqr(sqr(1+x1[delta_])-sqr(x1[px_])));
-             
-    coeff3 = hb*(x1[px_]/ps)/(1+sqr(x1[py_])/ps2) - sqr(hb)*gap*((ps2+sqr(x1[px_]))/ps3+sqr(x1[px_])/ps2*(ps2+x1[py_])/ps3);
-    coeff4 = -sqr(hb)*gap*4*sqr(x1[px_])*(1+x1[delta_])/ps5;
-        
-    if (coeff1 >= 0.0) {
-        x[y_] = 2.0 * x1[y_] / (1.0 + sqrt(coeff1));
-    } else {
-      //give the error message and set the unstable x value during the tracking
-             //this x value will be discard as an unstable value during the tracking
-        printf("bend_fringe: *** Speed of light exceeded!\n");
-        x[y_] = 10;
-	x[x_] = 10;
-	x[py_] =10;
-	x[ct_] = 10;
-     // exit_(1);
-    }
-
-  x[x_] += 0.5*coeff2*sqr(x[y_]);
-  x[py_]-= coeff3*x[y_];
-  x[ct_] -= 0.5*coeff4*sqr(x[y_]);
+        exit_(1);
+    }
 }
 
@@ -1450,7 +981,4 @@
     elemtype *elemp;
     MpoleType *M;
-    
-    ss_vect<T> x1, x2;
-    
 
     elemp = &Cell.Elem;
@@ -1460,5 +988,4 @@
     GtoL(x, Cell.dS, Cell.dT, M->Pc0, M->Pc1, M->Ps1);
 
-    //entrance of the magnet
     if ((M->Pmethod == Meth_Second) || (M->Pmethod == Meth_Fourth)) { /* fringe fields */
 
@@ -1468,23 +995,15 @@
         }
 
-        //fringe field and edge focusing of dipoles
-       if (M->Pirho != 0.0 && M->dipEdge_effect1 == 1){
-         if (!globval.H_exact) { //big ring */ modified linear term T43 on page 117 & 118 in SLAC-75.
-	               EdgeFocus(M->Pirho, M->PTx1, M->Pgap, x,true);
-	   } else {//small and big rings; Forest's model
-	  if(M->PH1!=0){
-	    // curvature of the magnet pole face; for a sector/wedge/rectangular dipole, this term is 0.
-	   BendCurvature(M->Pirho, M->PH1, x); 
-	  }
-	   p_rot(M->PTx1,  x);  //rotate from cartesian cooridnate to curlinear curved beam coordinate; 
-             // since the map of a sector dipole is used in Tracy 3 
-	   bend_fringe(M->Pirho, M->Pgap, x); //fringe field
-         }
-       }
+        if (!globval.H_exact) {
+            if (M->Pirho != 0.0)
+                EdgeFocus(M->Pirho, M->PTx1, M->Pgap, x);
+        } else {
+            p_rot(M->PTx1, x);
+            bend_fringe(M->Pirho, x);
+        }
     }
 
     if (M->Pthick == thick) {
-      if (!globval.H_exact || ((M->PTx1 == 0.0) && (M->PTx2 == 0.0))) {// polar coordinates,curvilinear coordinates
-      // if (M->n_design == Dip || ((M->PTx1 == 0.0) && (M->PTx2 == 0.0))) {// polar coordinates,curvilinear coordinates
+        if (!globval.H_exact || ((M->PTx1 == 0.0) && (M->PTx2 == 0.0))) {// polar coordinates,curvilinear coordinates
             h_ref = M->Pirho;
             dL = elemp->PL / M->PN;
@@ -1494,5 +1013,5 @@
                 dL = elemp->PL / M->PN;
             else
-                dL = 1.0 / M->Pirho * (sin(dtor(M->PTx1)) + sin(dtor(M->PTx2)))  //straight length of the dipole
+                dL = 1.0 / M->Pirho * (sin(dtor(M->PTx1)) + sin(dtor(M->PTx2)))
                         / M->PN;
         }
@@ -1522,23 +1041,9 @@
 
     case Meth_Second:
-      
-      //  cout << "Mpole_Pass: Meth_Second not supported" << endl;
-       // exit_(0);
-       // break;
-
-    //specially for the test of the dipole map,see Forest's beam dynamics, p361. eqn.(12.19)
- 
-    dL1 = 0.5*dL;
-    dL2 = dL;
-           
-            for (seg = 1; seg <= M->PN; seg++) {
-	      dipole_kick(dL1,M->Pirho,h_ref,x);
-	      multipole_kick(M->Porder, M->PB, dkL1, M->Pirho, x);
-	      dipole_kick(dL1,M->Pirho,h_ref,x);
-            }
-
-            
-       
-    case Meth_Fourth:  //forth order symplectic integrator
+        cout << "Mpole_Pass: Meth_Second not supported" << endl;
+        exit_(0);
+        break;
+
+    case Meth_Fourth:
         if (M->Pthick == thick) {
             dL1 = c_1 * dL;
@@ -1556,8 +1061,8 @@
                 }
 
-		 Drift(dL1, x);
+                Drift(dL1, x);
                 thin_kick(M->Porder, M->PB, dkL1, M->Pirho, h_ref, x);
                 Drift(dL2, x);
-		thin_kick(M->Porder, M->PB, dkL2, M->Pirho, h_ref, x);
+                thin_kick(M->Porder, M->PB, dkL2, M->Pirho, h_ref, x);
 
                 if (globval.emittance && (!globval.Cavity_on) && (M->Pirho
@@ -1566,9 +1071,8 @@
                     dI4 += 4.0 * is_tps<tps>::get_dI4(x);
                 }
-                
-                
+
                 Drift(dL2, x);
-		thin_kick(M->Porder, M->PB, dkL1, M->Pirho, h_ref, x);
-		Drift(dL1, x);
+                thin_kick(M->Porder, M->PB, dkL1, M->Pirho, h_ref, x);
+                Drift(dL1, x);
 
                 if (globval.emittance && (!globval.Cavity_on) && (M->Pirho
@@ -1594,21 +1098,13 @@
     }
 
-    //exit of the magnets
     if ((M->Pmethod == Meth_Second) || (M->Pmethod == Meth_Fourth)) {
-       
-      /* dipole fringe fields */
-             if (M->Pirho != 0.0 && M->dipEdge_effect2 == 1){
-	    if (!globval.H_exact) { //big ring, linear model correction
-	                       EdgeFocus(M->Pirho, M->PTx2, M->Pgap, x,false);
-	       }else{
-             bend_fringe(-M->Pirho, M->Pgap,x); //Forest's fringe field of the dipole
-	      p_rot(M->PTx2, x); //rotate back to the cartesian cooridinate
-	     if(M->PH2!=0){
-            // curvature of the magnet pole face; for a sector/wedge/rectangular dipole, this term is 0.
-             BendCurvature(M->Pirho, M->PH2, x);
-	     }
-         }
-     }
-        //quadrupole fringe field
+        /* fringe fields */
+        if (!globval.H_exact) {
+            if (M->Pirho != 0.0)
+                EdgeFocus(M->Pirho, M->PTx2, M->Pgap, x);
+        } else {
+            bend_fringe(-M->Pirho, x);
+            p_rot(M->PTx2, x);
+        }
         if (globval.quad_fringe && (M->PB[Quad + HOMmax] != 0.0) && (M->quadFF2
                 == 1))
@@ -2916,6 +2412,7 @@
     mergeto4by5(M, ah, av);
 }
-  /* **************************************************************  
-   * Compute transfert matrix for a quadrupole magnet
+
+void Mpole_Setmatrix(int Fnum1, int Knum1, double K) {
+    /*   Compute transfert matrix for a quadrupole magnet
      the transfert matrix A is plitted into two part
      A = AD55xAU55
@@ -2929,8 +2426,5 @@
      corresponding to a half magnet w/ an entrance
      angle and no exit angle.
-     The linear fringe field is taken into account                
-     **************************************************************/
-void Mpole_Setmatrix(int Fnum1, int Knum1, double K) {
-  
+     The linear frindge field is taken into account                    */
 
     CellType *cellp;
@@ -3426,5 +2920,5 @@
         printf("Elem_GetPos: there are no kids in family %d (%s)\n", Fnum1,
                 ElemFam[Fnum1 - 1].ElemF.PName);
-        exit_(1);
+        exit_(0);
     }
 
